Subject: Re: Getting a network interface list from within the kernel

From: David Howells <[email-masked]>
Date: Fri, 13 Apr 2007 12:37:18 +0100

David Miller <[email-masked]> wrote:

> Issue a RTM_GETLINK rtnetlink request, and parse the response.

Okay, I've managed to find code that does this.  However, RTM_GETLINK does not
appear to return any IPv4 addressing information.  It does, however, contain
the MTU details which is one of the three things I wanted.

I found that RTM_GETADDR will give me the IPv4 address and something from
which I can calculate the netmask.

I don't suppose there's a single op that will allow me to get all three in one
go?

Oh, and can I assume that the interface index numbers returned by RTM_GETLINK
match those returned by RTM_GETADDR?  Even if an interface is removed between
issuing the two calls?  Alternatively, do I need to compare interface names as
those are available between both?

David